//
//  Copyright (C) by S.Tomebechi 1994,1995
//  All rights reserved.
//
//  heap memory manager
//  ҡݥץ饹
//
//  created at 1994/Jun
//
//
#ifndef __MEMMAN_HPP
#define __MEMMAN_HPP
#include <stdlib.h>
#include <iostream.h>
#include <iomanip.h>
#include "Error.hpp"


class MemMan ;
class MemBlock ;

class Mem                   // ֥å long ȤƤߤ뤿
{                           // ƥץ졼
  friend class MemMan ;
  friend class MemBlock ;
  Mem(){}
  long size ;               // ФϤ
} ;

class MemBlock
{
  friend class MemMan ;
private:               // ٤ private
  MemBlock* pBlock ;   //  MemBlock ؤ
  Mem* availMem ;      // ƬΰõѤ褦ΰ
                       // ΤꤽնФƤ
                       // ºݤϺǸ allocate Ȥ
  Mem* pMem ;          // ֥åƬɥ쥹

  MemBlock(long BLOCK_SIZE)
  {
    pBlock=NULL ;
    pMem=new Mem[(BLOCK_SIZE+3)/4] ;
//    if( !pMem ) Error( allocate error ) ;
    pMem->size=(BLOCK_SIZE+3)/4-1 ;          // Ѳǽ祵
    (pMem+(BLOCK_SIZE+3)/4-1)->size=0 ;      // ü
    availMem=pMem ;
  }
  ~MemBlock() { delete [] pMem ; }
  Mem* alloc(long nunits) ;
  void merge(void) ;
public:
  void debug(long BLOCK_SIZE) ;   // debug Ѵؿ
  long check(long BLOCK_SIZE) ;   // debug 
} ;



class MemMan                // 꿶
{
  static unsigned long nalloc ;   // ǥХåѤѿ
  static unsigned long nfree ;
  static unsigned long nBlock ;

public:
  MemMan(long _size=0x00020000){
    BLOCK_SIZE=_size ;
    availBlock=NULL ;
    newBlock() ;
    availBlock->pBlock=availBlock ;
  }
  void* alloc(long nByte) ;  // Ƥ
  void free(void* p) ;

  void debug() ;      // debug 
  long check(char* file,int line) ;      // debug 

  ~MemMan() ;

private:

  MemBlock* availBlock ;
  long BLOCK_SIZE ;   // ֥åΥ

  void newBlock(void) ;

} ;

#endif


