//
//  Copyright (C) by S.Tomabechi 1993-1997
//  All rights reserved.
//
//  extended greatest common divisor 
//
//  ő񐔂 (a,b)=a*u+b*v 𖞂 u,v Ԃ
//   gcd Ɠl Lehmer@PȎZ@̕
//

#define _ONLY_MINTDECL_
#include "Mint.hpp"
#include "MintFunc.hpp"

#ifdef __BORLANDC__
#pragma inline

//  this=a*u+b*v 
Mint& Mint::isEGCD(const Mint& a,const Mint& b,
                   Mint& u,Mint& v)
{
  Mint v1(0) ;
  Mint q ;
  Mint t1,t3 ;
  Mint::_vvMtemp=b ;
  *this=a ;         // this <-> u3

                   // u=-1
  if( a.isNegative() ) {
    u.nDigit=1 ;
    *u.digit=1 ;
    u.nDim|=_NEGATIVE_ ; // ɂ
    nDim&=_POSITIVE_ ;
  }
  else {
    u.nDigit=1 ;
    *u.digit=1 ;
  }
//  if( a.Sign<0 ) { u.nDigit=1 ; *u.digit=1 ; u.Sign=-1 ; Sign=1 ; }
//  else { u.nDigit=1 ; *u.digit=1 ; }        // u=1

  if( b.isZero() ) {
    v.nDigit=1 ;
    *v.digit=1 ;
    return *this ;
  }

  if( b.isNegative() ) Mint::_vvMtemp.nDim&=_POSITIVE_ ;

  for(;;) {
    if( Mint::_vvMtemp.isZero() ) {
      v=(*this-a*u)/b ;
      return *this ;
    }
    divide(*this,Mint::_vvMtemp,q,t3) ;

    __asm {                   // swap *this <-> t3
                              // {,*this <- t3 Ƃ邾ł悢
                              // ̕
      mov   ebx,this

      mov   eax,[ebx]
      xchg  eax,dword ptr t3.digit
      mov   [ebx],eax

      mov   eax,[ebx.nDigit]
      xchg  eax,dword ptr t3.nDigit
      mov   [ebx.nDigit],eax

      mov   eax,[ebx.nDim]
      xchg  eax,dword ptr t3.nDim
      mov   [ebx.nDim],eax

    }


    u-=q*v1 ;  //   u<->v1
    if( this->isZero() ) {
      v=(Mint::_vvMtemp-a*v1)/b ;
      Swap(u,v1) ;
      Swap(*this,_vvMtemp) ;
      return *this ;
//      return *this=Mint::_vvMtemp ;
    }

    divide(Mint::_vvMtemp,*this,q,t3) ;
    __asm {
      mov   eax,dword ptr [@Mint@_vvMtemp]
      xchg  eax,dword ptr t3.digit
      mov   dword ptr [@Mint@_vvMtemp],eax

      mov   eax,dword ptr [@Mint@_vvMtemp.nDigit]
      xchg  eax,dword ptr t3.nDigit
      mov   dword ptr [@Mint@_vvMtemp.nDigit],eax

      mov   eax,dword ptr [@Mint@_vvMtemp.nDim]
      xchg  eax,dword ptr t3.nDim
      mov   dword ptr [@Mint@_vvMtemp.nDim],eax

    }

    v1 -= q*u ;

  }

}

#else
Mint& Mint::isEGCD(const Mint& a,const Mint& b,
                   Mint& u,Mint& v)
{
  Mint v1(0) ;
  Mint q ;
  Mint t1,t3 ;
  Mint::_vvMtemp=b ;
  *this=a ;         // this <-> u3

  if( a.isNegative()) {
    u.nDigit=1 ;
    *u.digit=1 ;
    u.nDim|=_NEGATIVE_ ;
    nDim&=_POSITIVE_ ;
  }
  else { u.nDigit=1 ; *u.digit=1 ; }

  if( b.isZero() ) {
    v.nDigit=1 ;
    *v.digit=1 ;
    return *this ;
  }

  if( b.isNegative() ) Mint::_vvMtemp.nDim&=_POSITIVE_ ;

  for(;;) {
    if( Mint::_vvMtemp.isZero() ) {
      v=(*this-a*u)/b ;
      return *this ;
    }
    divide(*this,Mint::_vvMtemp,q,t3) ;
    Swap(*this,t3) ;    // 肽Ԃ񑬂 ?


    u-=q*v1 ;  //   u<->v1
    if( this->isZero() ) {
      v=(Mint::_vvMtemp-a*v1)/b ;
      Swap(u,v1) ;
      Swap(*this,_vvMtemp) ;
      return *this ;
//      return *this=Mint::_vvMtemp ;
    }

    divide(Mint::_vvMtemp,*this,q,t3) ;
    Swap(Mint::_vvMtemp,t3) ;
    v1-=q*u ;

  }

}
#endif