//
//  Copyright (C) by S.Tomabechi 1993,1994,1995
//  All rights reserved.
//
//   (Greatest Common Divisor) 

#ifdef __BCC__
#pragma inline
#endif

//#define _ONLY_MINTDECL_
#include "Mint.hpp"

unsigned long gcd(const unsigned long m,const unsigned long n) ;

Mint& Mint::isGCD(const Mint& u,const Mint& v)
{
  unsigned long w ;
  _uuMtemp=u ;
  _vvMtemp=v ;
#ifdef __BCC__
  __asm {
    mov byte ptr [@Mint@_uuMtemp].nDim[3],1          // _uuMtemp <- abs(_uuMTemp)
    mov byte ptr [@Mint@_vvMtemp].nDim[3],1
  }
#else
  _uuMtemp.nDim&=_POSITIVE_ ;
  _vvMtemp.nDim&=_POSITIVE_ ;
#endif
  for(;;) {
                                   // stop if v=0
    if( _vvMtemp.nDigit<=1 ) {     // single precision
      w=(unsigned long)_vvMtemp ;
      if( w==0 ) {
        Swap(*this,_uuMtemp) ;
        return *this ;
//        return *this=_uuMtemp ;    // v=0
      }
      else return *this=gcd(_uuMtemp.isRemUL(w),w) ;
    }
    _uuMtemp.isRem(_uuMtemp,_vvMtemp) ;

                  // դĤϡu  v 򴹤ƾν֤
                  // åפ˽. ֤󤳤®.
    if( _uuMtemp.nDigit<=1 ) {
      w=(unsigned long)_uuMtemp ;
      if( w==0 ) {
        Swap(*this,_vvMtemp) ;
        return *this ;
//        return *this=_vvMtemp ;
      }
      else return *this=gcd(_vvMtemp.isRemUL(w),w) ;
    }
    _vvMtemp.isRem(_vvMtemp,_uuMtemp) ;
  }
}
