//
//  Copyright (C) by S.Tomabechi 1997
//  All rights reserved.
//
//  Montgomery reduction class
//  (not fast)
//
#ifdef __BORLANDC__
#pragma inline
#endif
#include "Mont.hpp"

//Mint Mont::modulus ;
//Mint Mont::inverse ;
//Mint Mont::IR ;
//Mont Mont::_Motemp ;
//unsigned long Mont::mantissa ;

bool Mont::SetModulus(const Mint& N)
{
  if( Even(N) ) Error(must be odd) ;
  mantissa=(long)N.nDigit ;
  modulus=N ;
  Mint R(1) ;
//  Mint IR ;
  R[mantissa] ;     // R=(2^32)^mantissa
  if( egcd(N,R,inverse,IR)!=1 ) Error(not coprime) ;
  ~inverse ;
//  while( inverse.Sign<0 ) inverse+=R ;
  while( inverse.isNegative() ) inverse+=R ;
  return true ;
}





Mont& Mont::power(const Mont& x,const Mint& n)
{
  long j(0),k ;
  unsigned long d ;
  long leng ;
  Mont xx ;
  leng=ilog2(n) ;
  if( sign(n)>=0 ) xx=x ;
  else {
    xx.isInverse(x) ;
  }
  *this=1 ;
//  rep=R%modulus ;
  if( leng>=0 ) for(;;) {
    d=n.digit[j++] ;
    for( k=32 ; k!=0 ; k-- ) {
      if( d&1 ) isMul(*this,xx)  ;
      if( --leng<0 ) goto RET1 ;
      d>>=1 ;
      xx.isMul(xx,xx) ;
    }
  }
RET1: ;
  return *this ;
}

