//
//	Copyright (C) by S.Tomabechi 1993,1994,1995
//	All rights reserved.
//
//	output multiple precision number
//
//	dxo
//

#define _ONLY_MINTDECL_
#include "Mint.hpp"
#include <iostream.h>
#include <iomanip.h>
#include "IntFuncs.hpp"
#include <math.h>

::ostream& operator<<(::ostream& os,const Mint& a)
{
#ifdef __BORLANDC__
  long m=(long)ceill(1.9265919722494798*a.nDigit) ;
#else
  long m=(long)ceil(1.9265919722494798*a.nDigit) ;
#endif
  m++ ; 			  // m is length of integer as 10^5-adic number
					  // it does not need to be accurate but not be less

					 // ̌ς͐młȂĂ悢߂Ă͂Ȃ.
  a.Put(os,m) ;
  return os ;
}

//
//	m : \ׂ (10^5 iƂĂ̌)
//	\́A10iĕ\Ă悤Ɍ邪Aۂ10^5iƂĕ\
//	ĂƂKł. ۂɂĂ邱Ƃ́A2^32 10^5
//	ւ̊ϊ
//
long Mint::Put(ostream& os,long& m) const
{
  static long nenter=0 ;	// ċAĂяõlXg̐[
  static long kdigit=0 ;
  static bool first=true ;
  static long mdigit ;
  long k ;
  long j ;
  Mint w ;

  if( nenter==0 ) mdigit=m ;	// \ׂۑ

				// 傫Ȑł. ĕ\.
#if 0
  if( m>256*8192 ) {
	Mint* t=new Mint ;
	if( !t ) { os << " too big number " ; return 0 ; }
	Mint r ;
	long n ;
	k=ilog2(m)-1 ;
							// *this>=t^2 ƂȂ悤 tƂ
	for( *t=_decimal,j=0 ; j<k ; j++ ) (*t) *= (*t) ; // (10^5)^(2^k)

	divide(*this,*t,w,r) ;	// this=w*t+r, w  rɕĕ\

	n=1 ;
	n<<=k ; 				// t ̌

	delete t ;				// pς, ̂Ă. ֗̂̓
							// gpĂƂ
	nenter++ ;
	w.Put(os,k=m-n) ;		// w  (this ̌- ť)\
	r.nDim &= _POSITIVE_ ;
	r.Put(os,n) ;			// r  n(t ̌)\

	if( (--nenter)==0 ) first=1 ;  // ׂĕ\
	return kdigit ;
  }
#endif

  long* d=new long[m] ;

  if( !d ) {					   // z񂪊mۂłȂ
	os << "too big number" ;	   // \łȂȂ̂ŏIȂ
	nenter=0 ;
	kdigit+=10 ;
	return kdigit ;
  }

  w=*this ;
//	w.Sign=1 ;
  w.nDim &= _POSITIVE_ ;

  for( j=0 ; j<m ; j++ ) {			   // ϊ
	w/=_decimal ;
	d[j]=Mint::_res ;
  }

  if( first ) { 					   // ߂ďo͂
	kdigit=0 ;		// m ̌ς肪Ă邱Ƃ̂ ڂ
	for( ; m >=2 ; m-- ) {			   // 擪 0 łȂT
	  if( d[m-1]!=0 ) break ;
	  mdigit-- ;					   // 10^5iƂĐ
	}
	if( Mint::format==noSpace ) {
	  kdigit=mdigit ;
	  kdigit %= _digits_1line ;
	  if( kdigit!=0 ) kdigit=_digits_1line-kdigit ;
	  if( mdigit<=_digits_1line ) kdigit=0 ;
	  else os << endl ;
	}
	else if( Mint::format==digit5 ) {
	  kdigit=mdigit ;
	  kdigit%=10 ;
	  if( kdigit!=0 ) kdigit=10-kdigit ;
	  if( mdigit<=10 ) kdigit=0 ;
	  else os << endl ;
	}
  }

  if( format==digit5 ) {	  // 5󔒂ŋ؂ďo
	if( first ) {			  // 
	  if( mdigit>10 )  for( j=0 ; j<kdigit ; j++ ) os << "      " ;
	  if( isNegative() ) {
		if( d[m-1]==0 ) os << "    -0" ;
		else if( d[m-1]<10000 ) os << setw(6) << setfill(' ') << -d[m-1] ;
		else os << '-' << d[m-1] ;
	  }
	  else	os << setw(6) << setfill(' ') << d[m-1] ;
	  j=m-2 ;
	  if( (++kdigit)%10==0 ) os << endl ;
	  mdigit-- ;
	  if( m==1 ) goto RET1 ;
	}
	else j=m-1 ;

	for( ; j>=0 ; j-- ) {
	  os << ' ' << setw(5) << setfill('0') << d[j]	 ;
	  if( (++kdigit)%10==0	) os << endl ; // outpur 50 digits and 50o͂As
										   // 500 o͂s
	  if( (--mdigit)!=0 && mdigit%100==0 ) os << endl ;
	}

  }
  else if( format==noSpace ) {				// eAďo
	if( first ) {
	  if( mdigit>_digits_1line ) for( j=0 ; j<kdigit ; j++ ) os << "     " ;
	  if( mdigit>_digits_1line ) {
		if( isNegative() ) {
		  if( d[m-1]==0 ) os << "    -0" ;
														  // 5
		  else if( d[m-1]<10000 ) os << setw(5) << setfill(' ') << -d[m-1] ;
		  else os << '-' << d[m-1] ;
		}
		else os << setw(5) << setfill(' ') << d[m-1] ;
	  }
	  else {
		if( isNegative() ) {
		  if( d[m-1]==0 ) os << "-0" ;
														  // 5
		  else if( d[m-1]<10000 ) os << -d[m-1] ;
		  else os << '-' << d[m-1] ;
		}
		else os << d[m-1] ;
	  }
	  if( (++kdigit)%_digits_1line==0 ) os << endl ;
	  if( m==1 ) goto RET1 ;
	  j=m-2 ;
	}
	else  j=m-1 ;

	for( ; j>=0 ; j-- ) {
	  os << setw(5) << setfill('0') << d[j]   ;
	  if( (++kdigit)%_digits_1line==0 ) os << endl	;
	}

  }
  else {
	if( isNegative() ) {
	  if( d[m-1]==0 ) os << "-0" ;
	  else if( d[m-1]<10000 ) os <<  -d[m-1] ;	// 5
	  else os << '-' << d[m-1] ;
	}
	else os << d[m-1] ;

	for( k=1,j=m-2 ; j>=1 ; j-- ) {
	  os << setw(5) << setfill('0') << d[j]   ;
	}
	if( m!=1 ) os << setw(5) << setfill('0') << d[0] ;
  }
RET1:

  first=false ;
  delete [] d ;
  if( nenter==0 ) first=true ;	  // So͂.

  return kdigit ;				  // o͂Ԃ

}
