//
//  Copyright (C) by S.Tomabechi 1995-1997
//  All rights reserved.
//
//  Sieve Part of MPQS method
//
//  1995/03/07 쐬
//
//  1996/11/25
//   PPMPQSpɕύX
//   ʒu߂ōςނ悤ɂ

//
//  unsigned long nPrimes :  f̌
//  unsigned long SieveWidth2 : ӂ邤S͈
//  unsigned long SieveUnit   : łӂ邤͈
//
//  SievePos[0] 
//  SievePos[1] : ʒu
//  SievePos[2] : ʒu
#ifdef __BORLANDC__
#pragma inline
#endif

#define _ONLY_MINTDECL_
#include "Mint.hpp"

extern long Rootp[] ;
extern long SievePos[] ;
extern char logP[] ;
extern unsigned long _A[] ;
extern unsigned long _B[] ;
extern unsigned long Primes[] ;
extern unsigned long nSieveResult ;
extern unsigned long SieveResult[] ;
extern Mint _a ;
extern Mint _b ;
extern const unsigned long SieveUnit ;
extern unsigned long SieveWidth ;
extern unsigned long SieveWidth2 ;
extern char Cutoff ;

extern unsigned long _nPrimes ;
extern unsigned long _mPrimes ;
extern unsigned long _mPrimes2 ;
extern unsigned long _lPrimes ;
extern char SieveArray[] ;

extern long _nResult ;      // ӂ邢Ɏc

void Sieve(void)
{
  unsigned long nPrimes ;
  unsigned long nPrimes2 ;
  unsigned long off ;
  unsigned long andigit ;
  unsigned long bndigit  ;
  unsigned long a2_p ;
  long b_p ;
  long r_p ;
  long Mmodp ;
  long v3 ;
  long t3 ;
  unsigned long p ;

Initialize:
  __asm {
//    cld
#ifdef __BORLANDC__
    mov   ecx,dword ptr [_a.nDigit]      // 
    mov   andigit,ecx
    mov   esi,dword ptr [_a]
    lea   edi,_A                      // ]ȏACacheqbg̊֌W
    rep   movsd                       // Rs[悢ʂ

    mov   ecx,dword ptr [_b.nDigit]      // 
    mov   bndigit,ecx
    mov   esi,dword ptr [_b]
    lea   edi,_B
    rep   movsd
#else
    mov   ecx,[_a+NDIGIT]      // 
    mov   andigit,ecx
    mov   esi,[_a+DIGIT]
    lea   edi,_A                       // ]ȏACacheqbg̊֌W
    rep   movsd                        // Rs[悢ʂ

    mov   ecx,[_b+NDIGIT]      // 
    mov   bndigit,ecx
    mov   esi,[_b+DIGIT]
    lea   edi,_B
    rep   movsd
#endif

    mov   eax,_mPrimes
    mov   nPrimes,eax
    sub   nPrimes,2                     // -1()  2 ͏
    mov   edi,1
  }

LOOP1:
    __asm {
                                        // fo
                                        // esi <-> Primes Ƃ
                                        // edi <-> SievePos 
      inc   edi
      mov   esi,[Primes+edi*4]

      lea   ebx,[edi*2+edi]            // ebx=3*edi
      mov   eax,[SievePos+ebx*4]
      mov   r_p,eax

      mov   eax,[SieveWidth]
      xor   edx,edx
      div   esi
      mov   Mmodp,edx                   // SieveWidth mod p

                                        // a mod p  ߂
      mov   ebx,andigit                 // 
      xor   edx,edx
    }
DIV:                                    // mod p vZ
    __asm {
      mov   eax,[_A+ebx*NBYTE-NBYTE]
      div   esi
      dec   ebx
      jnz   DIV

      shl   edx,1                       // 2*a mod p
      mov   a2_p,edx

                                        // -b mod p ߂
      mov   ebx,bndigit                 // 
      xor   edx,edx
    }
DIV_b:
    __asm {
      mov   eax,[_B+ebx*NBYTE-NBYTE]
      div   esi
      dec   ebx
      jnz   DIV_b

      neg   edx
      add   edx,esi                     // ]ɂ
      mov   b_p,edx                     // b_p<p łKv͂Ȃ

      xor   ebx,ebx                     // 2a^-1 mod p vZ
  }
Check_a:
  __asm {

    mov   v3,esi
    mov   ecx,1                         // ecx is inverse
    mov   eax,a2_p                      // ȉ eax=a
  }
DIV1:
  __asm {
    xor   edx,edx
    div   v3                            // a/v3
    mov   t3,edx                        // ]Z|u
    mul   ebx
    sub   ecx,eax                       // ecx -= q*v1
    xchg  ecx,ebx
    mov   eax,t3
    or    eax,eax
    jz    RET1
    xchg  eax,v3
    jmp   DIV1
  }

RET1:

   __asm {
     add   ecx,esi

     mov   eax,b_p                      // eax=-b
     add   eax,r_p                      //  -b+r mod p

     mul   ecx                          // 2a ̋t
     div   esi

     sub   edx,Mmodp                    // fŊŌ̈ʒu߂
     js    Neg1
     sub   edx,esi
   }
Neg1:
  __asm {
     add   edx,[SieveUnit]
     mov   ebx,edx

  }


   __asm {

     mov   eax,b_p                      // eax=-b
     sub   eax,r_p                      // -b-r modp r^2=pN mod p
     add   eax,esi                      // eax ɂȂ悤ɂ

     mul   ecx                          // a2 ̋t
     div   esi

     sub   edx,Mmodp
     js    Neg2
     sub   edx,esi
   }
Neg2:
  __asm {
     add  edx,[SieveUnit]

     cmp  ebx,edx
     jge  SET1
     xchg ebx,edx                       // SievePos[+1]>SievePos[+2]
                                        // ƂȂ悤ɂ
  }
SET1:
  __asm {
     lea  esi,[edi*2+edi]
     mov  [SievePos+esi*4+4],ebx        // fŊŌ̈ʒu
     mov  [SievePos+esi*4+8],edx

     dec  nPrimes
     jnz  LOOP1
  }

RET:

  __asm {
      mov  eax,_mPrimes2
      mov  nPrimes2,eax
    }

LOOP2:                                  // 2 ̙pŊʒûӂ邢
    __asm {
      dec  nPrimes2
      js   RET2

                                        // 2 ̙po
      inc   edi
      mov   esi,[Primes+edi*4]
      lea   ebx,[edi*2+edi]
      mov   eax,[SievePos+ebx*4]

      mov   r_p,eax

      mov   edx,[SieveWidth]
      dec   esi
      and   edx,esi
      mov   Mmodp,edx

      mov   edx,[_A]          // a mod p vZ
      and   edx,esi
      mov   a2_p,edx

      mov  edx,[_B]           // -b mod p vZ
      and  edx,esi
      inc  esi

      neg   edx
      add   edx,esi
      mov   b_p,edx
    }


  __asm {

    xor   ebx,ebx

    mov   v3,esi                        // v3=p
    mov   ecx,1                         // ecx is inverse
    mov   eax,a2_p
  }
DIV2:
  __asm {
    xor   edx,edx
    div   v3                            // a/v3
    mov   t3,edx                        // ]Z|u
    mul   ebx
    sub   ecx,eax                       // ecx -= q*v1
    xchg  ecx,ebx

    mov   eax,t3
    or    eax,eax
    jz    RET12
    xchg  eax,v3
    jmp  DIV2

  }

RET12:
   __asm {
     add    ecx,esi

     mov   eax,b_p                      // eax=-b
     add   eax,r_p


     shr   eax,1
     dec   esi
     and   eax,esi

     mul   ecx                          // a2 ̋t
     and   eax,esi
     inc   esi

     sub   eax,Mmodp
     js    Neg11
     sub   eax,esi
   }
Neg11:
  __asm {
     add   eax,[SieveUnit]

     mov   ebx,eax

     mov   eax,b_p                      // eax=-b
     sub   eax,r_p
     add   eax,esi
   }
NOT_EXCEED2:
  __asm {

     shr   eax,1
     dec   esi                          // ebx=p 
     and   eax,esi

     mul   ecx                          // a2 ̋t
     and   eax,esi
     inc   esi

     sub   eax,Mmodp
     js    Neg12
     sub   eax,esi
   }
Neg12:
  __asm {
     add   eax,[SieveUnit]

      cmp  ebx,eax
      jge  SET2
      xchg ebx,eax
  }
SET2:
  __asm  {
     lea   esi,[edi*2+edi]
     mov   [SievePos+esi*4+4],ebx
     mov   [SievePos+esi*4+8],eax
     jmp   LOOP2
  }
RET2:

  __asm {
    mov   [_nResult],0
    mov   eax,[SieveWidth2]
    mov   off,eax
  }

MORE:
  __asm {
    mov   edx,[SieveUnit]
    sub   off,edx
    jc    RET9
  }

  __asm {

    mov   eax,-1
    mov   ecx,edx
    shr   ecx,2
    lea   edi,SieveArray
    rep   stosd
  }
  __asm {
    mov   esi,dword ptr [_lPrimes]
    dec   esi
    cmp   off,0
    je    MAINLOOP2
 }

MAINLOOP1:                              // ̃[vƂ
    __asm {
      dec   esi
      jz    SetResult
                                        // fo
      mov   ecx,[Primes+esi*4+4]

      mov   al,[logP+esi+1]             // al <- logP

      lea   edi,[esi*2+esi]
      mov   ebx,[SievePos+edi*4+16]
      mov   edx,[SievePos+edi*4+20]

      or    ebx,ebx
      jl    LOOP_END1                   // ʒuȂꍇ

      or    edx,edx
      jl    SUB2
    }
SUB1:
  __asm {
    sub   byte ptr [SieveArray+ebx],al
    sub   byte ptr [SieveArray+edx],al
    sub   ebx,ecx
    sub   edx,ecx
    js    END_SUB1                      // CfbNXɂȂ܂ŉ
    sub   byte ptr [SieveArray+ebx],al
    sub   byte ptr [SieveArray+edx],al
    sub   ebx,ecx
    sub   edx,ecx
    jns   SUB1                          // CfbNXɂȂ܂ŉ
  }
END_SUB1:
  __asm {
//    cmp   ebx,0
    or    ebx,ebx
    jl    LOOP_END1
  }

SUB2:
  __asm {
    sub   byte ptr [SieveArray+ebx],al
    sub   ebx,ecx
    xchg  ebx,edx
  }

LOOP_END1:
    __asm {
      add   ebx,[SieveUnit]
      add   edx,[SieveUnit]
      mov   [SievePos+edi*4+16],ebx
      mov   [SievePos+edi*4+20],edx

      jmp   MAINLOOP1
    }

MAINLOOP2:
    __asm {
      dec  esi
      jz   SetResult

                                        // fo
      mov   ecx,[Primes+esi*4+4]

      mov   al,[logP+esi+1]             // al <- logP

      lea   edi,[esi*2+esi]
      mov   ebx,[SievePos+edi*4+16]
      mov   edx,[SievePos+edi*4+20]

      or    ebx,ebx
      jl    LOOP_END2

      or    edx,edx
      jl    SUB22
    }
SUB21:
  __asm {
    sub byte ptr [SieveArray+ebx],al
    sub byte ptr [SieveArray+edx],al
    sub ebx,ecx
    sub edx,ecx
    jns SUB21                           // CfbNXɂȂ܂ŉ

    or  ebx,ebx
    jl  LOOP_END2
  }

SUB22:
  __asm {
    sub  byte ptr [SieveArray+ebx],al
    sub  ebx,ecx
    xchg ebx,edx
  }

LOOP_END2:
    __asm {
      mov   [SievePos+edi*4+16],ebx
      mov   [SievePos+edi*4+20],edx

      jmp   MAINLOOP2
    }


SetResult:
  __asm {
    mov   ecx,off
    mov   ebx,[SieveUnit]
    dec   ebx
    mov   esi,[_nResult]

    mov   al,Cutoff
  }
Count:
  __asm {
    cmp   al,byte ptr [SieveArray+ebx]   // > Cutoff ?
    ja    Set_Index
  }
NEXT:
  __asm {
    dec   ebx
    jns   Count
    jmp   Set_Count
  }
Set_Index:
  __asm {
    mov   edx,ebx
    add   edx,ecx
    mov   [SieveResult+esi*4],edx
    inc   esi

//cmp   esi,nSieveResult                // 256 ȏɂȂ߂
//jb    CCC                            // ԂKvȂ,Ô
//mov   [_nResult],esi
//jmp   RET9
//}
//CCC:
//__asm {

    dec   ebx
    jns   Count
  }
Set_Count:
  __asm {
    mov  [_nResult],esi
    jmp MORE
  }
RET9: ;

}

