%include "mint.inc"
[BITS 32]
	extrn	@power$qxulxt1xt1
	extrn	@Kronecker$qxulxt1
	public	@sqrt$qxulxt1
[SECTION .text]	
@sqrt$qxulxt1
   ;	
   ;	unsigned long sqrt(const unsigned long a,const unsigned long p)
   ;	
	push      ebp
	mov       ebp,esp
	add       esp,-20
	push      ebx
	push      esi
	push      edi
   ;	
   ;	{
   ;	
   ;	  unsigned long q ;
   ;	  unsigned long r ;
   ;	
   ;	  __asm {
   ;	    mov ebx,p
   ;	
@1
	mov	 ebx,dword ptr [ebp+12]
   ;	
   ;	  }
   ;	Check_a
   ;	  __asm {
   ;	    mov eax,a             // a%p
   ;	
	mov	 eax,dword ptr [ebp+8]             
   ;	
   ;	    xor edx,edx
   ;	
	xor	 edx,edx
   ;	
   ;	    div ebx
   ;	
	div	 ebx
   ;	
   ;	
   ;	    or  edx,edx
   ;	
	or	  edx,edx
   ;	
   ;	    jz  RET0
   ;	
;	je        @2
	jne 	@99_2
	jmp		@2
@99_2	
   ;	
   ;	  }
   ;	OK
   ;	  __asm {
   ;	    mov eax,ebx
   ;	
	mov	 eax,ebx
   ;	
   ;	    and eax,3              // p mod 4
   ;	
	and	 eax,3              
   ;	
   ;	    cmp eax,3
   ;	
	cmp	 eax,3
   ;	
   ;	    jne mod8
   ;	
;	je        @4
	jne 		@99_4
	jmp			@4
@99_4	
   ;	
   ;	    jmp RET1
   ;	  }
   ;	
   ;	mod8                      // p!=3 mod 4
   ;	  __asm {
   ;	    mov eax,ebx
   ;	
@3
	mov	 eax,ebx
   ;	
   ;	    and eax,7             // p mod 8
   ;	
	and	 eax,7             
   ;	
   ;	    cmp eax,5             // p=5 mod 8 ?
   ;	
	cmp	 eax,5             
   ;	
   ;	    jne CASE1
   ;	
;	je        @6
	jne 	@99_6
	jmp		@6
@99_6	
   ;	
   ;	    jmp CASE5
   ;	  }
   ;	CASE1
   ;	  __asm {
   ;	    cmp eax,1
   ;	
@5
	cmp	 eax,1
   ;	
   ;	    je  Shanks
   ;	
;	jne       @8
	je		@99_8
	jmp		@8
@99_8	
   ;	
   ;	    jmp RETa
   ;	  }
   ;	Shanks
   ;	  __asm {
   ;	    xor esi,esi
   ;	
@7
	xor	 esi,esi
   ;	
   ;	    mov eax,ebx
   ;	
	mov	 eax,ebx
   ;	
   ;	    dec eax
   ;	
	dec	 eax
   ;	
   ;	  }
   ;	EVEN
   ;	  __asm {
   ;	    test eax,1
   ;	
@9
	test	 eax,1
   ;	
   ;	    jnz  EXIT_LOOP
   ;	
	jne       short @10
   ;	
   ;	    inc esi
   ;	
	inc	 esi
   ;	
   ;	    shr eax,1
   ;	
	shr	 eax,1
   ;	
   ;	    jmp EVEN
   ;	
	jmp       short @9
   ;	
   ;	  }
   ;	EXIT_LOOP
   ;	  __asm {
   ;	    mov r,esi
   ;	
@10
	mov	 dword ptr [ebp-8],esi
   ;	
   ;	    mov q,eax                 // p-1=2^r*q
   ;	
	mov	 dword ptr [ebp-4],eax                 
   ;	
   ;	  }
   ;	
   ;	   unsigned long nn(p) ;
   ;	
	mov       eax,dword ptr [ebp+12]
	mov       dword ptr [ebp-12],eax
   ;	
   ;	   unsigned long n ;
   ;	Find_generator               // ȯ
   ;	
   ;	   __asm {
   ;	     mov eax,nn
   ;	
@11
	mov	 eax,dword ptr [ebp-12]
   ;	
   ;	     mov ebx,1664525
   ;	
	mov	 ebx,1664525
   ;	
   ;	     mul ebx
   ;	
	mul	 ebx
   ;	
   ;	     add eax,1013904223
   ;	
	add	 eax,1013904223
   ;	
   ;	     mov nn,eax
   ;	
	mov	 dword ptr [ebp-12],eax
   ;	
   ;	     xor edx,edx
   ;	
	xor	 edx,edx
   ;	
   ;	     div p
   ;	
	div	 dword ptr [ebp+12]
   ;	
   ;	     mov n,edx
   ;	
	mov	 dword ptr [ebp-16],edx
   ;	
   ;	   }
   ;	   if( Kronecker(n,p)!=-1 ) goto Find_generator ;
   ;	
	push      dword ptr [ebp+12]
	push      dword ptr [ebp-16]
	call      @Kronecker$qxulxt1
	add       esp,8
	inc       eax
	jne       @11
   ;	
   ;	Initialize
   ;	  unsigned long y=power(n,q,p) ;
   ;	
@12
	push      dword ptr [ebp+12]
	push      dword ptr [ebp-4]
	push      dword ptr [ebp-16]
	call      @power$qxulxt1xt1
	add       esp,12
	mov       dword ptr [ebp-20],eax
	push      dword ptr [ebp+12]
	mov       edx,dword ptr [ebp-4]
	dec       edx
	shr       edx,1
	push      edx
	push      dword ptr [ebp+8]
	call      @power$qxulxt1xt1
	add       esp,12
	mov       dword ptr [ebp-4],eax
   ;	
   ;	  q=power(a,(q-1)>>1,p) ;
   ;	
   ;	  __asm {
   ;	    mov ebx,p             // ebx <- p ʸ
   ;	
	mov	 ebx,dword ptr [ebp+12]             
   ;	
   ;	    mov eax,q             // x=q
   ;	
	mov	 eax,dword ptr [ebp-4]             
   ;	
   ;	    mul eax               //  x*x
   ;	
	mul	 eax               
   ;	
   ;	    div ebx               //  edx <- (x*x) mod p
   ;	
	div	 ebx               
   ;	
   ;	    mov eax,a
   ;	
	mov	 eax,dword ptr [ebp+8]
   ;	
   ;	    mov ecx,eax
   ;	
	mov	 ecx,eax
   ;	
   ;	    mul edx               //  a*((x*x) mod p)
   ;	
	mul	 edx               
   ;	
   ;	    div ebx               //  mod p
   ;	
	div	 ebx               
   ;	
   ;	    mov a,edx             // a=b
   ;	
	mov	 dword ptr [ebp+8],edx             
   ;	
   ;	
   ;	    mov eax,q
   ;	
	mov	 eax,dword ptr [ebp-4]
   ;	
   ;	    mul ecx               // * a
   ;	
	mul	 ecx               
   ;	
   ;	    div ebx
   ;	
	div	 ebx
   ;	
   ;	    mov q,edx             // x <- x*a mod p
   ;	
	mov	 dword ptr [ebp-4],edx             
   ;	
   ;	  }
   ;	LOOP
   ;	  __asm {
   ;	    mov eax,a
   ;	
@13
	mov	 eax,dword ptr [ebp+8]
   ;	
   ;	    cmp eax,1
   ;	
	cmp	 eax,1
   ;	
   ;	    je  RETq
   ;	
	je        @14
   ;	
   ;	    mul eax               // b*b
   ;	
	mul	 eax               
   ;	
   ;	    div ebx               // edx <- b*b mod p
   ;	
	div	 ebx               
   ;	
   ;	    mov edi,1
   ;	
	mov	 edi,1
   ;	
   ;	  }
   ;	IS_1
   ;	  __asm {
   ;	    cmp edx,1             // b2=1 ?
   ;	
@15
	cmp	 edx,1             
   ;	
   ;	    je  LEAVE
   ;	
	je        short @16
   ;	
   ;	    mov eax,edx
   ;	
	mov	 eax,edx
   ;	
   ;	    mul edx               // eax <- eax *eax
   ;	
	mul	 edx               
   ;	
   ;	    div ebx               // mod p   edx=b^2
   ;	
	div	 ebx               
   ;	
   ;	    inc edi
   ;	
	inc	 edi
   ;	
   ;	    jmp IS_1
   ;	
	jmp       short @15
   ;	
   ;	  }
   ;	LEAVE
   ;	  __asm {
   ;	    cmp edi,r
   ;	
@16
	cmp	 edi,dword ptr [ebp-8]
   ;	
   ;	    je  RET00
   ;	
;	je        @2
	jne 	@98_2
	jmp		@2
@98_2
   ;	
   ;	    mov eax,y
   ;	
	mov	 eax,dword ptr [ebp-20]
   ;	
   ;	    mov edx,eax
   ;	
	mov	 edx,eax
   ;	
   ;	    mov ecx,r
   ;	
	mov	 ecx,dword ptr [ebp-8]
   ;	
   ;	    sub ecx,edi
   ;	
	sub	 ecx,edi
   ;	
   ;	    dec ecx
   ;	
	dec	 ecx
   ;	
   ;	    jz  MUL_LOOP_END
   ;	
	je        short @18
   ;	
   ;	  }
   ;	MUL_LOOP
   ;	  __asm {
   ;	    mul eax
   ;	
@19
	mul	 eax
   ;	
   ;	    div ebx
   ;	
	div	 ebx
   ;	
   ;	    mov eax,edx
   ;	
	mov	 eax,edx
   ;	
   ;	    dec ecx
   ;	
	dec	 ecx
   ;	
   ;	    jnz MUL_LOOP
   ;	
	jne       short @19
   ;	
   ;	  }
   ;	MUL_LOOP_END
   ;	  __asm {
   ;	    mov esi,edx
   ;	
@18
	mov	 esi,edx
   ;	
   ;	    mov eax,esi
   ;	
	mov	 eax,esi
   ;	
   ;	    mul esi
   ;	
	mul	 esi
   ;	
   ;	    div ebx
   ;	
	div	 ebx
   ;	
   ;	    mov y,edx   // y <- (t^2)%p
   ;	
	mov	 dword ptr [ebp-20],edx   
   ;	
   ;	
   ;	    mov eax,a   //
   ;	
	mov	 eax,dword ptr [ebp+8]   
   ;	
   ;	    mul edx
   ;	
	mul	 edx
   ;	
   ;	    div ebx
   ;	
	div	 ebx
   ;	
   ;	    mov a,edx   // b<-(b*y)%p
   ;	
	mov	 dword ptr [ebp+8],edx   
   ;	
   ;	
   ;	    mov r,edi   // r <- m
   ;	
	mov	 dword ptr [ebp-8],edi   
   ;	
   ;	
   ;	    mov eax,q
   ;	
	mov	 eax,dword ptr [ebp-4]
   ;	
   ;	    mul esi
   ;	
	mul	 esi
   ;	
   ;	    div ebx
   ;	
	div	 ebx
   ;	
   ;	    mov q,edx
   ;	
	mov	 dword ptr [ebp-4],edx
   ;	
   ;	    jmp LOOP
   ;	
	jmp       @13
   ;	
   ;	  }
   ;	
   ;	RETq
   ;	  return q ;
   ;	
@14
	mov       eax,dword ptr [ebp-4]
	jmp       @20
   ;	
   ;	RET00
   ;	  goto RET0 ;
   ;	
   ;	CASE5
   ;	  if( power(a,(p-1)>>2,p)==1 ) {
   ;	
@17
@6
	push      dword ptr [ebp+12]
	mov       edx,dword ptr [ebp+12]
	dec       edx
	shr       edx,2
	push      edx
	push      dword ptr [ebp+8]
	call      @power$qxulxt1xt1
	add       esp,12
	cmp       eax,1
	jne       short @21
   ;	
   ;	    return power(a,(p+3)>>3,p) ;
   ;	
	push      dword ptr [ebp+12]
	mov       ecx,dword ptr [ebp+12]
	add       ecx,3
	shr       ecx,3
	push      ecx
	push      dword ptr [ebp+8]
	call      @power$qxulxt1xt1
	add       esp,12
	jmp       @20
   ;	
   ;	  }
   ;	  else {
   ;	            // (2*a*power(4*a,(p-5)/8,p))%p 
   ;	            // ñ˼ޤʤᥢ֥
   ;	    __asm {
   ;	      mov   eax,a
   ;	
@21
	mov	   eax,dword ptr [ebp+8]
   ;	
   ;	      xor   edx,edx
   ;	
	xor	   edx,edx
   ;	
   ;	      shld  edx,eax,2
   ;	
	shld	  edx,eax,2
   ;	
   ;	      shl   eax,2
   ;	
	shl	   eax,2
   ;	
   ;	      div   p
   ;	
	div	   dword ptr [ebp+12]
   ;	
   ;	      mov   r,edx
   ;	
	mov	   dword ptr [ebp-8],edx
   ;	
   ;	    }
   ;	
   ;	    q=power(r,(p-5)>>3,p) ;
   ;	
	push      dword ptr [ebp+12]
	mov       eax,dword ptr [ebp+12]
	sub       eax,5
	shr       eax,3
	push      eax
	push      dword ptr [ebp-8]
	call      @power$qxulxt1xt1
	add       esp,12
	mov       dword ptr [ebp-4],eax
   ;	
   ;	
   ;	    __asm {
   ;	      mov ecx,p
   ;	
	mov	 ecx,dword ptr [ebp+12]
   ;	
   ;	      mov eax,q
   ;	
	mov	 eax,dword ptr [ebp-4]
   ;	
   ;	      mul a
   ;	
	mul	 dword ptr [ebp+8]
   ;	
   ;	      div ecx
   ;	
	div	 ecx
   ;	
   ;	      mov eax,edx
   ;	
	mov	 eax,edx
   ;	
   ;	      xor edx,edx
   ;	
	xor	 edx,edx
   ;	
   ;	      shld edx,eax,1
   ;	
	shld	 edx,eax,1
   ;	
   ;	      shl  eax,1
   ;	
	shl	  eax,1
   ;	
   ;	      div ecx
   ;	
	div	 ecx
   ;	
   ;	      mov q,edx
   ;	
	mov	 dword ptr [ebp-4],edx
   ;	
   ;	      jmp RETq
   ;	
	jmp       @14
   ;	
   ;	    }
   ;	  }
   ;	RET0
   ;	  return 0 ;
   ;	
@22
@2
	xor       eax,eax
	jmp       short @20
   ;	
   ;	RETa
   ;	  return a ;
   ;	
@8
	mov       eax,dword ptr [ebp+8]
	jmp       short @20
   ;	
   ;	RET1
   ;	  return power(a,(p+1)>>2,p) ;
   ;	
@4
	push      dword ptr [ebp+12]
	mov       edx,dword ptr [ebp+12]
	inc       edx
	shr       edx,2
	push      edx
	push      dword ptr [ebp+8]
	call      @power$qxulxt1xt1
	add       esp,12
   ;	
   ;	}
   ;	
@23
@20
	pop       edi
	pop       esi
	pop       ebx
	mov       esp,ebp
	pop       ebp
	ret 
