/*------------------------------------------------------------------------*/
/*                                                                        */
/*  ERROR.HPP     error handling                                          */
/*                                                                        */
/*  Copyright (C) S.Tomabechi 1993                                        */
/*  All Rights Reserved                                                   */
/*                                                                        */
/*------------------------------------------------------------------------*/

#if !defined( __ERROR_HPP )
#define __ERROR_HPP

extern "C" void __assertfail(char* __msg,
             char* __cond,
             char* __file,
             int __line);

#undef Error


#define Err(error_msg) ((void) __assertfail(      \
        "Error occured : %s, file %s, line %d\n", \
       error_msg,__FILE__, __LINE__ ) )

#define Error(error_msg) ((void) __assertfail(      \
        "Error occured : %s, file %s, line %d\n", \
       #error_msg,__FILE__, __LINE__ ) )

#endif  // __ERROR_HPP
