%include "mint.inc"
[BITS 32]
	extrn	@$bnwa$qui
	extrn	@$bdla$qpv
	public	@FFT@initialize$qul
	extrn	@BitScanReverse$qxul
	extrn	@invmodp$qxulxt1
	extrn	@prmdiv$qxul
	extrn	@sqrt$qxulxt1
[SECTION .text]	
@FFT@initialize$qul
   ;	
   ;	bool FFTinitialize(unsigned long nsize)
   ;	
	push      ebp
	mov       ebp,esp
	add       esp,-28
	push      esi
   ;	
   ;	{
   ;	  unsigned long kk ;
   ;	  int iprime,j ;
   ;	  unsigned long p,proot ;
   ;	  unsigned long* rt ;
   ;	  logN=ilog2(nsize) ;                       // bit length
   ;	
@1
	mov       eax,dword ptr [ebp+12]
	mov       dword ptr [ebp-28],eax
	push      dword ptr [ebp-28]
	call      @BitScanReverse$qxul
	pop       ecx
	mov       edx,dword ptr [ebp+8]
	mov       dword ptr [edx+4],eax
   ;	
   ;	                                            // t=logN+1
   ;	  kk=1 ;
   ;	
	mov       dword ptr [ebp-4],1
   ;	
   ;	  kk<<=(32-logN) ;                          // 2^31 ʾǿȤ
   ;	
	mov       ecx,dword ptr [ebp+8]
	push      dword ptr [ecx+4]
	mov       ecx,32
	pop       eax
	sub       ecx,eax
	shl       dword ptr [ebp-4],cl
   ;	
   ;	  for( iprime=0 ; iprime<3 ; iprime++ ) {
   ;	
	xor       edx,edx
	mov       dword ptr [ebp-8],edx
   ;	
   ;	    if( N!=0 ) delete [] roots[iprime] ;
   ;	
@2
	mov       eax,dword ptr [ebp+8]
	mov       edx,dword ptr [eax]
	test      edx,edx
	je        short @4
	mov       ecx,dword ptr [ebp+8]
	mov       eax,dword ptr [ebp-8]
	push      dword ptr [ecx+4*eax+8]
	call      @$bdla$qpv
	pop       ecx
   ;	
   ;	    rt=new unsigned long[nsize+1] ;         // allocate table of roots
   ;	
@4
	mov       edx,dword ptr [ebp+12]
	inc       edx
	shl       edx,2
	push      edx
	call      @$bnwa$qui
	pop       ecx
	mov       dword ptr [ebp-24],eax
   ;	
   ;	    roots[iprime]=rt ;
   ;	
	mov       ecx,dword ptr [ebp+8]
	mov       eax,dword ptr [ebp-8]
	mov       edx,dword ptr [ebp-24]
	mov       dword ptr [ecx+4*eax+8],edx
   ;	
   ;	
   ;	    if( !rt ) return false ;
   ;	
	mov       ecx,dword ptr [ebp-24]
	test      ecx,ecx
	jne       short @5
	xor       eax,eax
	jmp       @6
   ;	
   ;	
   ;	    // search Fourier prime
   ;	    for(;;) {
   ;	      kk-- ;
   ;	
@5
@7
	dec       dword ptr [ebp-4]
   ;	
   ;	      p=kk*nsize+1 ;
   ;	
	mov       edx,dword ptr [ebp-4]
	imul      edx,dword ptr [ebp+12]
	inc       edx
	mov       dword ptr [ebp-16],edx
   ;	
   ;	     if( prmdiv(p)==1 ) break ;
   ;	
	push      dword ptr [ebp-16]
	call      @prmdiv$qxul
	pop       ecx
	cmp       eax,1
	jne       short @7
   ;	
   ;	    }
   ;	//cout << " init " << p ;
   ;	    proot=p-1 ;                             // -1 mod p  = sqrt(1) mod p
   ;	
@8
@10
@9
	mov       ecx,dword ptr [ebp-16]
	dec       ecx
	mov       dword ptr [ebp-20],ecx
   ;	
   ;	    rt[0]=1 ;
   ;	
	mov       eax,dword ptr [ebp-24]
	mov       dword ptr [eax],1
   ;	
   ;	    for( j=1 ; j<logN ; j++ ) {             // find primitive 2N-th root of unity
   ;	
	mov       dword ptr [ebp-12],1
	jmp       short @12
   ;	
   ;	//if( Kronecker(proot,p)!=1 ) Error(not root) ;
   ;	      proot=sqrt(proot,p) ;                 // square root in Z/pZ
   ;	
@11
	push      dword ptr [ebp-16]
	push      dword ptr [ebp-20]
	call      @sqrt$qxulxt1
	add       esp,8
	mov       dword ptr [ebp-20],eax
@13
	inc       dword ptr [ebp-12]
@12
	mov       edx,dword ptr [ebp+8]
	mov       ecx,dword ptr [edx+4]
	mov       eax,dword ptr [ebp-12]
	cmp       ecx,eax
	ja        short @11
   ;	
   ;	    }
   ;	    __asm {                                 // power of 2N-th root
   ;	      mov esi,rt
   ;	
	mov	 esi,dword ptr [ebp-24]
   ;	
   ;	      mov ecx,1
   ;	
	mov	 ecx,1
   ;	
   ;	      mov edx,ecx
   ;	
	mov	 edx,ecx
   ;	
   ;	    }
   ;	POWER
   ;	    __asm {
   ;	      mov eax,edx
   ;	
@14
	mov	 eax,edx
   ;	
   ;	      mul proot
   ;	
	mul	 dword ptr [ebp-20]
   ;	
   ;	      div p
   ;	
	div	 dword ptr [ebp-16]
   ;	
   ;	      mov dword ptr [ecx*4+esi],edx   // prime[j]=root^j mod p
   ;	
	mov	 dword ptr [ecx*4+esi],edx   
   ;	
   ;	      inc ecx
   ;	
	inc	 ecx
   ;	
   ;	      cmp ecx,nsize
   ;	
	cmp	 ecx,dword ptr [ebp+12]
   ;	
   ;	      jbe POWER
   ;	
	jbe       short @14
   ;	
   ;	    }
   ;	    inverse[iprime]=invmodp(nsize,p) ;  // N^-1 mod p
   ;	
	push      dword ptr [ebp-16]
	push      dword ptr [ebp+12]
	call      @invmodp$qxulxt1
	mov       edx,dword ptr [ebp+8]
	mov       ecx,dword ptr [ebp-8]
	add       esp,8
	mov       dword ptr [edx+4*ecx+20],eax
   ;	
   ;	    prime[iprime]=p ;
   ;	
	mov       eax,dword ptr [ebp+8]
	mov       edx,dword ptr [ebp-8]
	mov       ecx,dword ptr [ebp-16]
	mov       dword ptr [eax+4*edx+32],ecx
@15
	inc       dword ptr [ebp-8]
	mov       eax,dword ptr [ebp-8]
	cmp       eax,3
;	jl        @2
	jge 	@99_2
	jmp		@2
@99_2	
   ;	
   ;	  }
   ;	
   ;	            // for Chinese remainder theorem
   ;	  crt[0]=invmodp(prime[0],prime[1]) ;  // p0^-1 mod p1
   ;	
@3
	mov       edx,dword ptr [ebp+8]
	push      dword ptr [edx+36]
	mov       ecx,dword ptr [ebp+8]
	push      dword ptr [ecx+32]
	call      @invmodp$qxulxt1
	add       esp,8
	mov       edx,dword ptr [ebp+8]
	mov       dword ptr [edx+44],eax
   ;	
   ;	  crt[1]=invmodp(prime[0],prime[2]) ;  // p0^-1 mod p2
   ;	
	mov       eax,dword ptr [ebp+8]
	push      dword ptr [eax+40]
	mov       ecx,dword ptr [ebp+8]
	push      dword ptr [ecx+32]
	call      @invmodp$qxulxt1
	add       esp,8
	mov       edx,dword ptr [ebp+8]
	mov       dword ptr [edx+48],eax
   ;	
   ;	  crt[2]=invmodp(prime[1],prime[2]) ;  // p1^-1 mod p2
   ;	
	mov       eax,dword ptr [ebp+8]
	push      dword ptr [eax+40]
	mov       ecx,dword ptr [ebp+8]
	push      dword ptr [ecx+36]
	call      @invmodp$qxulxt1
	add       esp,8
	mov       edx,dword ptr [ebp+8]
	mov       dword ptr [edx+52],eax
   ;	
   ;	
   ;	     // lp0p1 low word of prime[0]*prime[1]
   ;	     // hp0p1 high word of prime[0]*prime[1]
   ;	  __asm {
   ;	    mov esi,this
   ;	
	mov	 esi,dword ptr [ebp+8]
   ;	
   ;	#ifdef __BCC__
   ;	    mov eax,dword ptr [esi].prime
   ;	    mul dword ptr [4+esi].prime
   ;	    mov dword ptr [esi].lp0p1,eax
   ;	    mov dword ptr [esi].hp0p1,edx
   ;	#else
   ;	    mov eax,dword ptr [esi+_PRIME]
   ;	
	mov	 eax,dword ptr [esi+32]
   ;	
   ;	    mul dword ptr [4+esi+_PRIME]
   ;	
	mul	 dword ptr [4+esi+32]
   ;	
   ;	    mov dword ptr [esi+_LP0P1],eax
   ;	
	mov	 dword ptr [esi+60],eax
   ;	
   ;	    mov dword ptr [esi+_HP0P1],edx
   ;	
	mov	 dword ptr [esi+56],edx
   ;	
   ;	#endif
   ;	  }
   ;	
   ;	  N=nsize ;
   ;	
	mov       eax,dword ptr [ebp+8]
	mov       ecx,dword ptr [ebp+12]
	mov       dword ptr [eax],ecx
   ;	
   ;	
   ;	#ifdef FFT_DEBUG
   ;	//cout << endl << "init " << N << " " << hex << p << dec ;
   ;	#endif
   ;	  return true ;
   ;	
	mov       al,1
   ;	
   ;	
   ;	}
   ;	
@16
@6
	pop       esi
	mov       esp,ebp
	pop       ebp
	ret 
