//
//  Copyright (C) by S.Tomabechi 1993-1997
//  All rights reserved.
//
//  reallocate array, copy memory
//
//  return value   true  : succeed
//                 flase : fail to allocate memory
//
//  gD̒ĺAۑD
//  ߂ĺA allocate ̏ꍇƓl
//
#ifdef __BORLANDC__
#pragma inline
#endif

#define _ONLY_MINTDECL_

#include "Mint.hpp"
#include "Error.hpp"

bool Mint::reallocate(int size)
{
  unsigned long* p ;
#ifdef _MEMMAN
if( size<=0 ) Error(size<=0) ;
#endif
  if( size>MAX_DIGITS ) Error(too big) ;
  if( !digit ) return allocate(size) ;
  else {
    if( size<ndim() ) return true ;      // do nothing because memory is enough.
    if( size<nDigit ) Error(size error) ;
//    size=Size>size ? Size:(++size) ;   // vTCY 1 傫TCY
                                         // Ŏ蒼
    size++ ;
    (nDim&=0xff000000)|=size ;
#ifdef _MEMMAN
    p=(unsigned long*)_MemMan.alloc(NBYTE*size) ;
#else
    p=new unsigned long[size] ;          // allocate error
#endif
    if( !p ) Error(reallocate error) ;
    __asm {
      mov   esi,this
#ifdef __BORLANDC__
      mov   ecx,[esi.nDigit]
      mov   eax,ecx
      mov   edi,p
      mov   esi,[esi]
//      cld
      rep   movsd             // memcpy(p,digit,4*nDigit) ;
      shl   eax,2
      sub   esi,eax
      sub   edi,eax
      mov   p,esi             // exchange address p<->digit
      mov   esi,this
      mov   [esi],edi
#else
      mov   ecx,[esi+NDIGIT]
      mov   eax,ecx
      mov   edi,p
      mov   esi,[esi]
//      cld
      rep   movsd             // memcpy(p,digit,4*nDigit) ;
      shl   eax,2
      sub   esi,eax
      sub   edi,eax
      mov   p,esi             // exchange address p<->digit
      mov   esi,this
      mov   [esi],edi
#endif
    }
#ifdef _MEMMAN
    _MemMan.free(p) ;
check(__FILE__,__LINE__) ;
#else
    delete [] p ;             // p is previous address
#endif
    return true ;
  }
}
