//
//	Copyright (C) by S.Tomabechi 2001
//	All rights reserved.
//
//
// ^ꂽ n ɂāA n ̖   r a߂
//
#include "Mint.hpp"


Mint sigma(const unsigned long n,const unsigned long r=1)
{
	Mint s=0 ;
	unsigned long sqn=isqrt(n) ;
	unsigned long q=1 ;
	unsigned long n_q ;
	for( q=1 ; q<=sqn ; q++ ) {
//		q=nextprm(q) ;
		if( n%q==0 ) {
			s+=power(q,r) ;
			if( (n_q=n/q)!=q ) {
				s+=power(n_q,r) ;
			}
		}
	}
	return s ;

}

#if 0
#include <stdlib.h>
#include "Error.hpp"
Mint sigma(const unsigned long n)
{
	Mint s=0 ;
	unsigned long sqn=isqrt(n) ;
	unsigned long q=1 ;
	for( q=1 ; q<=n ; q++ ) {
//		q=nextprm(q) ;
		if( n%q==0 ) {
			s+=q ;
		}
	}
	return s ;


}

int main(void)
{
	unsigned long n ;
	unsigned long r ;
	Mint sum ;
	Mint sum1 ;
	r=1 ;

	for( n=1 ; n<1000000 ; n++ ) {
		sum=sigma(n,r) ;
		sum1=sigma(n) ;
		if( sum1!=sum ) {
		cout << endl << sum << " " << sum1 ;
			Error(not same) ;
		}
		cout << endl << n << "      " << sum << " " << sum1 ;
	}
}
#endif